//===============================================================================
// Program : bcast.cpp
// Purpose : Generates an array, a[n] ( n = 100 ) on the root MPI process
//           ( rank 0 ), and broadcasts a[n] to all MPI processes
//
// Compile : mpicxx -o bcast.x bcast.cpp -O2
//===============================================================================
#include <iostream>
#include <mpi.h>
using namespace std;
int main(int argc, char** argv){
  int n = 100;
  int a[n];
  int i;
  int iproc;
  int nproc;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&iproc);
  MPI_Comm_size(MPI_COMM_WORLD,&nproc);
  if ( iproc == 0 ){
    for ( i = 1; i <= n; i++ ){
      a[i-1] = i;
    }
  }
  MPI_Bcast(&a,n,MPI_INTEGER,0,MPI_COMM_WORLD);
  if (iproc == 1){
    for ( i = 1; i <= n; i++ ){
      cout << iproc << '\t' << i << '\t' << a[i-1] << endl;
    }
  }
  MPI_Finalize();
  return 0;
}
