!===============================================================================
! Program : bcast.f90
! Purpose : Generates an array, a(n), on the root MPI proces (rank 0 ), and
!           broadcasts a(n) to all MPI processes
!
! Compile : mpif90 -o bcast.x bcast.f90 -O2
!===============================================================================
program main
  implicit none
  include 'mpif.h'
  integer(4), parameter :: n = 100
  integer(4) :: a(n)
  integer(4) :: i
  integer(4) :: ierr
  integer(4) :: iproc
  integer(4) :: nproc
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nproc, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, iproc, ierr)
  if ( iproc == 0 ) then
     do i = 1, n
        a(i) = i
     end do
  end if
  call MPI_BCAST(a,n,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
  if ( iproc == 1 ) then
     do i = 1, n
        write(6,*) iproc, i, a(i)
     end do
  end if
  call MPI_FINALIZE(ierr)
end program main
