!===============================================================================
! Program : comm_groups.f90
! Purpose : Illustrates managing communication groups. This program is designed
!           to run ot 4 MPI processes
!
! Compile : mpif90 -o comm_groups.x comm_groups.f90 -O2
!===============================================================================
program comm_groups
  implicit none
  include 'mpif.h'
  integer(4) :: i
  integer(4) :: ierr
  integer(4) :: iproc
  integer(4) :: nproc
  integer(4) :: newcomm
  integer(4) :: new_iproc
  integer(4) :: new_nproc
  integer(4) :: icolor
  integer(4) :: ikey
  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, nproc, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, iproc, ierr)
  if ( iproc == 0 ) then
     icolor = 1
     ikey = 2
  else if ( iproc == 1 ) then
     icolor = 1
     ikey = 1
  else if ( iproc == 2 ) then
     icolor = 2
     ikey = 1
  else if ( iproc == 3 ) then
     icolor = 2
     ikey = 2
  end if
  CALL MPI_COMM_SPLIT(MPI_COMM_WORLD, icolor, ikey, newcomm, ierr)
  call MPI_COMM_SIZE(newcomm, new_nproc, ierr)
  call MPI_COMM_RANK(newcomm, new_iproc, ierr)
  if ( icolor == 1 ) then
     if ( new_iproc == 0 ) write(6,*)"icolor = ", icolor
     write(6,*)"new_iproc = ", new_iproc, "iproc =", iproc
  else if ( icolor == 2 ) then
     if ( new_iproc == 0 ) write(6,*)"icolor = ", icolor
     write(6,*)"new_iproc = ", new_iproc, "iproc =", iproc
  end if
  call MPI_FINALIZE(ierr)
  stop
end program comm_groups
