//===============================================================================
// Program : psum1.cpp
// Purpose : Sums up elemnts of an array, a[n], using
//           block distribution
//
// Compile : mpicxx -o psum1.x psum1.cpp -O2
//===============================================================================
#include <iostream>
#include <mpi.h>
using namespace std;
int main(int argc, char** argv){
  int i;
  int n = 1000;
  int a[n];
  int sum;
  int ssum;
  int iproc;
  int nproc;
  int ista;
  int iend;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&iproc);
  MPI_Comm_size(MPI_COMM_WORLD,&nproc);
  for ( i = 1 + iproc; i <= n; i = i + nproc ){
    a[i-1] = i;
  }
  sum = 0;
  for ( i = 1 + iproc; i <= n; i = i + nproc ){
    sum = sum + a[i-1];
  }
  MPI_Reduce(&sum,&ssum,1,MPI_INTEGER,MPI_SUM,0,MPI_COMM_WORLD);
  sum = ssum;
  if ( iproc == 0 ){
    cout << "sum = " << sum << endl;
  }
  MPI_Finalize();
  return 0;
}
